//
//  Apostle1.h
//  ColorsWar
//
/*
 * HAZ™ Dev Group: http://imhaz.com
 *
 * Copyright (c) 2007-2011 HAZ™ Inc.
 *
 * Written by Hercy Chang 2011-12-08
 *
 */

#import <Foundation/Foundation.h>
#import "cocos2d.h"

#define kDataType @"dataType"

#define fDKShape @"theShape"
#define fDKcolor @"selfColor"

#define fDKmaxE @"maxEnergy"
#define fDKvD @"visualDistance"
#define fDKdS @"drawSpeed"
#define fDKhD @"healDistance"
#define fDKaD @"attackDistance"
#define fDKsS @"soulSpeed"

#define sDKTime @"datatime"
#define sDKPos @"position"
#define sDKRota @"rotation"
#define sDKBullet @"bullets"
#define sDKcurrentE @"currentEnergy"
#define sDKcS @"canSee"
#define sDKiD @"isDrawing"
#define sDKcB @"canBeHealed"
#define sDKsM @"soulMove"
#define sDKiA @"isAttacking"
#define sDKhS @"haveShield"

@interface ApostleBasis : CCSprite {
	int currentEnergy,maxEnergy;
	CGRect selfcolor;
	BOOL canSee,isDrawing,canBeHealed,soulMove,isAttacking,haveShield;
	float visualDistance;
	float drawDistance,healDistance,attackDistance,shieldRadius;
	float soulSpeed,drawSpeed,transparency;
	float selfsize;
	int sr,ad,vd,hd,dd,sd;
	CGPoint startPosition;
	NSMutableArray *theShape;
	NSMutableArray *bullets;
	int AIType,level;
}
@property (nonatomic,readwrite) CGPoint startPosition;
@property (nonatomic,readwrite) int currentEnergy,maxEnergy;
@property (nonatomic,readwrite) int AIType,level;
@property (nonatomic,readwrite) CGRect selfcolor;
@property (nonatomic,readwrite) BOOL canSee,isDrawing,canBeHealed,soulMove,isAttacking,haveShield;
@property (nonatomic,readwrite) float visualDistance,selfsize,transparency;
@property (nonatomic,readwrite) float drawDistance,healDistance,attackDistance,shieldRadius;
@property (nonatomic,readwrite) float soulSpeed,drawSpeed;
@property (nonatomic,retain) NSMutableArray *theShape;
@property (nonatomic,retain) NSMutableArray* bullets;

-(NSDictionary*)selfFeatures;
+(id)createFrom:(NSDictionary*)d;

-(NSDictionary*)currentStatus;
-(void)refreshFrom:(NSDictionary*)d;

-(void)pasteFrom:(ApostleBasis*)ap;
-(void)changeShape;
-(void)becomeActiveExplore;
-(void)becomeActiveVS;
-(void)becomeActiveShow;
-(void)calculateSize;
-(void)turnto:(float)angle atSpeed:(float)speedtoturn;
-(void)shoot:(CGRect)bc From:(CGPoint)sp To:(ApostleBasis*)tp Angle:(float)an Speed:(float)s Range:(float)r Damage:(int)d;
-(void)shoot:(CGRect)bc From:(CGPoint)sp Angle:(float)an Speed:(float)s Range:(float)r Damage:(int)d Shape:(int)sh Radius:(float)ra;
-(void)changeBulletSpeedTo:(float)ns;
-(void)changeBulletDamageTo:(float)nd;
-(void)changeBulletRotationTo:(float)nr;
-(void)AIturnto:(float)angle moveAtSpeed:(float)speed;
-(void)doAIActionTo:(ApostleBasis *)target AtSpeed:(float)s;
@end
