//
//  Apostle1.m
//  ColorsWar
//
/*
 * HAZ™ Dev Group: http://imhaz.com
 *
 * Copyright (c) 2007-2011 HAZ™ Inc.
 *
 * Written by Hercy Chang 2011-12-08
 *
 */

/*
 default:
 
 self.drawSpeed = 2;
 self.soulSpeed = 30;
 self.drawDistance = 60;
 self.healDistance = 30;
 self.visualDistance = 300;
 self.shieldRadius = 70;
 self.attackDistance = 800;
 self.startPosition = ccp(0,0);
 currentEnergy = maxEnergy = 1000;
 
 */
/*
 AIType:
 0 -- the Player without AI
 1 -- direct attacker
 2 -- shooter
 3 -- ninja
 4 -- ghost
 5 -- font
 6 -- transformer
 */

#import "ApostleBasis.h"
#import "DataLayer.h"
#import "CWColor.h"
#import "GameView.h"
#import "AnimationLayer.h"

@implementation ApostleBasis

@synthesize startPosition;
@synthesize currentEnergy,maxEnergy;
@synthesize selfcolor;
@synthesize canSee,isDrawing,canBeHealed,soulMove,isAttacking,haveShield;
@synthesize visualDistance,drawDistance,healDistance,drawSpeed,soulSpeed;
@synthesize attackDistance,shieldRadius,selfsize,transparency;
@synthesize theShape;
@synthesize bullets;
@synthesize AIType,level;
-(void)dealloc{
	[super dealloc];
	//[bullets removeAllObjects];
	//[theShape removeAllObjects];
	[bullets release];
	[theShape release];
}

-(NSDictionary*)selfFeatures{
	NSDictionary *sF = [NSDictionary dictionaryWithObjectsAndKeys:
						[NSNumber numberWithInteger:NETWORK_INIT_DATA],kDataType,
						[NSDate date],sDKTime,
						self.theShape,fDKShape,
						[NSValue valueWithCGRect:selfcolor],fDKcolor,
						[NSNumber numberWithFloat:maxEnergy],fDKmaxE,
						[NSNumber numberWithFloat:visualDistance],fDKvD,
						[NSNumber numberWithFloat:drawSpeed],fDKdS,
						[NSNumber numberWithFloat:healDistance],fDKhD,
						[NSNumber numberWithFloat:attackDistance],fDKaD,
						[NSNumber numberWithFloat:soulSpeed],fDKsS,
						nil];
	return sF;
}

+(id)createFrom:(NSDictionary *)d{
	ApostleBasis *e = [ApostleBasis node];
	e.theShape = [d objectForKey:fDKShape];
	e.selfcolor = [[d objectForKey:fDKcolor] CGRectValue];
	e.maxEnergy = [[d objectForKey:fDKmaxE] floatValue];
	e.visualDistance = [[d objectForKey:fDKvD] floatValue];
	e.drawSpeed = [[d objectForKey:fDKdS] floatValue];
	e.healDistance = [[d objectForKey:fDKhD] floatValue];
	e.attackDistance = [[d objectForKey:fDKaD] floatValue];
	e.soulSpeed = [[d objectForKey:fDKsS] floatValue];
	[e calculateSize];
	return e;
}

int booltoint(BOOL b){
	if(b==YES)
		return 1;
	else {
		return 0;
	}
}

BOOL inttobool(int i){
	if(i<=0)
		return NO;
	else {
		return YES;
	}

}

-(NSDictionary*)currentStatus{
	NSDictionary *sF = [NSDictionary dictionaryWithObjectsAndKeys:
						[NSNumber numberWithInteger:NETWORK_STREAM_DATA],kDataType,
						[NSDate date],sDKTime,
						[NSValue valueWithCGPoint:self.position],sDKPos,
						[NSNumber numberWithFloat:self.rotation],sDKRota,
						//self.bullets,sDKBullet,
						[NSNumber numberWithFloat:self.currentEnergy],sDKcurrentE,
						[NSNumber numberWithInt:vd],sDKcS,
						[NSNumber numberWithInt:dd],sDKiD,
						[NSNumber numberWithInt:hd],sDKcB,
						[NSNumber numberWithInt:sd],sDKsM,
						[NSNumber numberWithInt:ad],sDKiA,
						[NSNumber numberWithInt:sr],sDKhS,
						nil];
	return sF;	
}

-(void)refreshFrom:(NSDictionary *)d{
	self.position = [[d objectForKey:sDKPos] CGPointValue];
	self.rotation = [[d objectForKey:sDKRota] floatValue];
	
	//self.bullets = [d objectForKey:sDKBullet];
	self.currentEnergy = [[d objectForKey:sDKcurrentE] intValue];
	
	int visd = [[d objectForKey:sDKcS] intValue];
	int drad = [[d objectForKey:sDKiD] intValue];
	int heald = [[d objectForKey:sDKcB] intValue];
	int sould = [[d objectForKey:sDKsM] intValue];
	int attd = [[d objectForKey:sDKiA] intValue];
	int sheild = [[d objectForKey:sDKhS] intValue];
	
	self.haveShield = inttobool(sheild);
	sr = sheild;
	
	self.canSee = inttobool(visd);
	vd = visd;
	
	self.canBeHealed = inttobool(heald);
	hd = heald;

	if(self.isDrawing == inttobool(drad)){
		dd = drad;
	}
	else {
		self.isDrawing = inttobool(drad);
	}
	
	if (self.soulMove == inttobool(sould)) {
		sd = sould;
	}
	else {
		self.soulMove = inttobool(sould);
	}
	
	if (self.isAttacking == inttobool(attd)) {
		ad = attd;
	}
	else {
		self.isAttacking = inttobool(attd);
	}
}

-(void)pasteFrom:(ApostleBasis *)ap{
	sr=vd=ad=hd=dd=0;
	transparency = 0.0f;
	self.level = ap.level;
	self.AIType = ap.AIType;
	self.visible = ap.visible;
	self.drawSpeed = ap.drawSpeed;
	self.soulSpeed = ap.soulSpeed;
	self.drawDistance = ap.drawDistance;
	self.healDistance = ap.healDistance;
	self.visualDistance = ap.visualDistance;
	self.shieldRadius = ap.shieldRadius;
	self.attackDistance = ap.attackDistance;
	self.startPosition = ap.startPosition;
	self.selfcolor = ap.selfcolor;
	currentEnergy = ap.currentEnergy;
	maxEnergy = ap.maxEnergy;
	[theShape removeAllObjects];
	[theShape addObjectsFromArray:ap.theShape];
	[self calculateSize];	
}

-(void)shoot:(CGRect)bc From:(CGPoint)sp To:(ApostleBasis*)tp Angle:(float)an Speed:(float)s Range:(float)r Damage:(int)d
{
	NSMutableDictionary *abullet = [NSMutableDictionary dictionaryWithObjectsAndKeys:
									[NSValue valueWithCGPoint:sp],kBStart,
									[NSValue valueWithCGPoint:sp],kBPosition,
									tp,kBTarget,
									[NSValue valueWithCGRect:bc],kBColor,
									[NSNumber numberWithFloat:selfsize],kBRadius,
									[NSNumber numberWithFloat:r],kBRange,
									[NSNumber numberWithFloat:s],kBSpeed,
									[NSNumber numberWithFloat:an],kBRotation,
									[NSNumber numberWithInt:d],kBDamage,
									[NSNumber numberWithInt:3],kBShape,
									nil];
	[bullets addObject:abullet];
}

-(void)shoot:(CGRect)bc From:(CGPoint)sp Angle:(float)an Speed:(float)s Range:(float)r Damage:(int)d Shape:(int)sh Radius:(float)ra
{
	NSMutableDictionary *abullet = [NSMutableDictionary dictionaryWithObjectsAndKeys:
									[NSValue valueWithCGPoint:sp],kBStart,
									[NSValue valueWithCGPoint:sp],kBPosition,
									[NSValue valueWithCGRect:bc],kBColor,
									[NSNumber numberWithFloat:ra],kBRadius,
									[NSNumber numberWithFloat:r],kBRange,
									[NSNumber numberWithFloat:s],kBSpeed,
									[NSNumber numberWithFloat:an],kBRotation,
									[NSNumber numberWithInt:d],kBDamage,
									[NSNumber numberWithInt:sh],kBShape,
									nil];
	[bullets addObject:abullet];	
}

-(void)changeBulletSpeedTo:(float)ns{
	for(NSMutableDictionary *abullet in bullets){
		[abullet setObject:[NSNumber numberWithFloat:ns] forKey:kBSpeed];
	}
}

-(void)changeBulletDamageTo:(float)nd{
	for(NSMutableDictionary *abullet in bullets){
		[abullet setObject:[NSNumber numberWithFloat:nd] forKey:kBDamage];
	}
}

-(void)changeBulletRotationTo:(float)nr{
	for(NSMutableDictionary *abullet in bullets){
		[abullet setObject:[NSNumber numberWithFloat:nr] forKey:kBRotation];
	}	
}

-(void)turnto:(float)angle atSpeed:(float)speedtoturn{
	if(fabsf(angle-self.rotation)<=0.1){
		return;
	}
	if(self.rotation>360)self.rotation = self.rotation - 360;
	if(self.rotation<0)self.rotation = self.rotation + 360;
	if((angle - self.rotation)<=180&&(self.rotation - angle)<=180)
		self.rotation = (angle - self.rotation)/speedtoturn+self.rotation;
	else if(angle>self.rotation) 
		self.rotation = self.rotation - (360 - angle + self.rotation)/speedtoturn;
	else self.rotation = self.rotation + (360 - self.rotation + angle)/speedtoturn;
	
}

-(void)changeShape{
	[theShape removeAllObjects];
	switch (AIType) {
		case 1:
			[theShape addObject:[NSValue valueWithCGPoint:ccp(0,0)]];
			[theShape addObject:[NSValue valueWithCGPoint:ccp(-20,-50)]];
			[theShape addObject:[NSValue valueWithCGPoint:ccp(-30,0)]];
			[theShape addObject:[NSValue valueWithCGPoint:ccp(-10,-50)]];
			[theShape addObject:[NSValue valueWithCGPoint:ccp(0,50)]];
			[theShape addObject:[NSValue valueWithCGPoint:ccp(10,-50)]];
			[theShape addObject:[NSValue valueWithCGPoint:ccp(30,0)]];
			[theShape addObject:[NSValue valueWithCGPoint:ccp(20,-50)]];
			break;
		case 2:
			[theShape addObject:[NSValue valueWithCGPoint:ccp(0,50)]];
			[theShape addObject:[NSValue valueWithCGPoint:ccp(50,0)]];
			[theShape addObject:[NSValue valueWithCGPoint:ccp(10,20)]];
			[theShape addObject:[NSValue valueWithCGPoint:ccp(18,-30)]];
			[theShape addObject:[NSValue valueWithCGPoint:ccp(50,-50)]];
			[theShape addObject:[NSValue valueWithCGPoint:ccp(24,0)]];
			[theShape addObject:[NSValue valueWithCGPoint:ccp(0,-50)]];
			[theShape addObject:[NSValue valueWithCGPoint:ccp(-24,0)]];
			[theShape addObject:[NSValue valueWithCGPoint:ccp(-50,-50)]];			
			[theShape addObject:[NSValue valueWithCGPoint:ccp(-18,-30)]];			
			[theShape addObject:[NSValue valueWithCGPoint:ccp(-10,20)]];			
			[theShape addObject:[NSValue valueWithCGPoint:ccp(-50,0)]];			
			break;
		case 3:
			[theShape addObject:[NSValue valueWithCGPoint:ccp(0,-13)]];			
			[theShape addObject:[NSValue valueWithCGPoint:ccp(-20,-27)]];			
			[theShape addObject:[NSValue valueWithCGPoint:ccp(0,30)]];			
			[theShape addObject:[NSValue valueWithCGPoint:ccp(20,-27)]];			
			break;
		case 4:
			[theShape addObject:[NSValue valueWithCGPoint:ccp(-15,9)]];			
			[theShape addObject:[NSValue valueWithCGPoint:ccp(-12,-24)]];			
			[theShape addObject:[NSValue valueWithCGPoint:ccp(0,50)]];			
			[theShape addObject:[NSValue valueWithCGPoint:ccp(12,-24)]];			
			[theShape addObject:[NSValue valueWithCGPoint:ccp(15,9)]];			
			[theShape addObject:[NSValue valueWithCGPoint:ccp(-27,-10)]];			
			[theShape addObject:[NSValue valueWithCGPoint:ccp(27,-10)]];			
			break;
		case 5:
			[theShape addObject:[NSValue valueWithCGPoint:ccp(0,32)]];			
			[theShape addObject:[NSValue valueWithCGPoint:ccp(-50,-50)]];			
			[theShape addObject:[NSValue valueWithCGPoint:ccp(-12,50)]];			
			[theShape addObject:[NSValue valueWithCGPoint:ccp(0,-50)]];			
			[theShape addObject:[NSValue valueWithCGPoint:ccp(12,50)]];			
			[theShape addObject:[NSValue valueWithCGPoint:ccp(50,-50)]];			
			break;
		case 6:
			[theShape addObject:[NSValue valueWithCGPoint:ccp(-16,20)]];			
			[theShape addObject:[NSValue valueWithCGPoint:ccp(0,-50)]];			
			[theShape addObject:[NSValue valueWithCGPoint:ccp(16,20)]];			
			[theShape addObject:[NSValue valueWithCGPoint:ccp(17,-24)]];			
			[theShape addObject:[NSValue valueWithCGPoint:ccp(-50,-50)]];			
			[theShape addObject:[NSValue valueWithCGPoint:ccp(6,-16)]];			
			[theShape addObject:[NSValue valueWithCGPoint:ccp(0,50)]];			
			[theShape addObject:[NSValue valueWithCGPoint:ccp(-6,-16)]];			
			[theShape addObject:[NSValue valueWithCGPoint:ccp(50,-50)]];			
			[theShape addObject:[NSValue valueWithCGPoint:ccp(-17,-24)]];			

			break;

		default:
			break;
	}
	[self calculateSize];
}

-(void)calculateSize{
	float dis = 0;
	int totalnum=0;
	for(NSValue *apoint in theShape){
		CGPoint p = [apoint CGPointValue];
		dis+=sqrtf(p.x*p.x+p.y*p.y);
		totalnum++;
	}
	dis = dis/totalnum;
	selfsize = dis*0.7+15;
}

-(id)init{
	if((self=[super init])){
		sr=vd=ad=hd=dd=sd=0;
		transparency = 0.0f;
		self.level = 0;
		self.AIType = 0;
		self.visible = NO;
		self.canSee = NO;
		self.isDrawing = NO;
		self.canBeHealed = NO;
		self.soulMove = NO;
		self.isAttacking = NO;
		self.haveShield = NO;
		self.drawSpeed = 4+13;
		self.soulSpeed = 100+200;
		self.drawDistance = 60;
		self.healDistance = 20+10;
		self.visualDistance = 240+120;
		self.shieldRadius = 0;
		self.attackDistance = 400+400;
		self.startPosition = ccp(0,0);
		self.selfcolor = CGRectMake(CCRANDOM_0_1(), CCRANDOM_0_1(), CCRANDOM_0_1(), CCRANDOM_0_1());
		currentEnergy = maxEnergy = 4000+2000;
		bullets = [[NSMutableArray alloc] init];
		theShape = [[NSMutableArray alloc] init];
		[theShape addObject:[NSValue valueWithCGPoint:ccp(-15,-15)]];
		[theShape addObject:[NSValue valueWithCGPoint:ccp(15,-15)]];
		[theShape addObject:[NSValue valueWithCGPoint:ccp(0,27)]];
		[self calculateSize];
	}
	return self;
}
void betterLine(CGPoint sp,CGPoint ep,CGRect startc,CGRect endc,CGRect edgecolor,float width)
{
	float anglestoe = AngleOfTwoPoints(sp, ep);
	float radfactor = (float)M_PI/180;
	
	GLfloat vertices[12];
	GLfloat colors[24];
	
	float dx1 = width/2*sinf((anglestoe+90)*radfactor);
	float dy1 = width/2*cosf((anglestoe+90)*radfactor);
	float dx2 = width/2*sinf((anglestoe+270)*radfactor);
	float dy2 = width/2*cosf((anglestoe+270)*radfactor);
	
	vertices[0] = sp.x+dx1;
	vertices[1] = sp.y+dy1;
	vertices[2] = ep.x+dx1;
	vertices[3] = ep.y+dy1;
	vertices[4] = sp.x;
	vertices[5] = sp.y;
	vertices[6] = ep.x;
	vertices[7] = ep.y;
	vertices[8] = sp.x+dx2;
	vertices[9] = sp.y+dy2;
	vertices[10] = ep.x+dx2;
	vertices[11] = ep.y+dy2;
	
	colors[0] = colors[4] = colors[16] = colors[20] = edgecolor.origin.x;
	colors[1] = colors[5] = colors[17] = colors[21] = edgecolor.origin.y;
	colors[2] = colors[6] = colors[18] = colors[22] = edgecolor.size.width;
	colors[3] = colors[7] = colors[19] = colors[23] = edgecolor.size.height;
	
	colors[8] = startc.origin.x;
	colors[9] = startc.origin.y;
	colors[10] = startc.size.width;
	colors[11] = startc.size.height;
	
	colors[12] = endc.origin.x;
	colors[13] = endc.origin.y;
	colors[14] = endc.size.width;
	colors[15] = endc.size.height;
	
	glDisable(GL_TEXTURE_2D);
	glDisableClientState(GL_TEXTURE_COORD_ARRAY);
	
	glColorPointer(4, GL_FLOAT, 0, colors);
	glVertexPointer(2, GL_FLOAT, 0, vertices);	
	glDrawArrays(GL_TRIANGLE_STRIP, 0, 6);
	
	// restore default state
	glEnableClientState(GL_TEXTURE_COORD_ARRAY);
	glEnable(GL_TEXTURE_2D);		
	
}

void selfDraw( NSArray* points, CGRect centercolor, CGRect edgecolor , float width )
{
	int num = [points count];
	for(int i=0;i<num;i++){
		CGPoint p1,p2;
		if(i==num-1){
			p1 = [[points lastObject] CGPointValue];
			p2 = [[points objectAtIndex:0] CGPointValue];
		}
		else {
			p1 = [[points objectAtIndex:i] CGPointValue];
		    p2 = [[points objectAtIndex:i+1] CGPointValue];	
		}
		betterLine(p1, p2, centercolor, centercolor, edgecolor, width);
	}		
}

void draw2Circle( CGPoint center,float r1, float r2, CGRect color1, CGRect color2, int numofpoint)
{
	const float coef = (float)M_PI*2/numofpoint;
	
	GLfloat *vertices = calloc( sizeof(GLfloat)*2*(numofpoint+1)*2, 1);
	GLfloat *colors = calloc( sizeof(GLfloat)*4*(numofpoint+1)*2, 1);
	if( ! vertices || ! colors)
		return;
	
	vertices[0] = center.x;
	vertices[1] = center.y+r1;
	vertices[2] = center.x;
	vertices[3] = center.y+r2;
	colors[0] = color1.origin.x;
	colors[1] = color1.origin.y;
	colors[2] = color1.size.width;
	colors[3] = color1.size.height;
	colors[4] = color2.origin.x;
	colors[5] = color2.origin.y;
	colors[6] = color2.size.width;
	colors[7] = color2.size.height;
	
	for(NSUInteger i=1;i<(numofpoint+1);i++)
	{
		float rads = i*coef;
		GLfloat ix1 = r1 * sinf(rads) + center.x;
		GLfloat iy1 = r1 * cosf(rads) + center.y;
		GLfloat ix2 = r2 * sinf(rads) + center.x;
		GLfloat iy2 = r2 * cosf(rads) + center.y;
		
		vertices[i*4] = ix1 * CC_CONTENT_SCALE_FACTOR();
		vertices[i*4+1] = iy1 * CC_CONTENT_SCALE_FACTOR();
		vertices[i*4+2] = ix2 * CC_CONTENT_SCALE_FACTOR();
		vertices[i*4+3] = iy2 * CC_CONTENT_SCALE_FACTOR();
		
		colors[i*8] = color1.origin.x;
		colors[i*8+1] = color1.origin.y;
		colors[i*8+2] = color1.size.width;
		colors[i*8+3] = color1.size.height;
		
		colors[i*8+4] = color2.origin.x;
		colors[i*8+5] = color2.origin.y;
		colors[i*8+6] = color2.size.width;
		colors[i*8+7] = color2.size.height;
	}
	
	// Default GL states: GL_TEXTURE_2D, GL_VERTEX_ARRAY, GL_COLOR_ARRAY, GL_TEXTURE_COORD_ARRAY
	// Needed states: GL_VERTEX_ARRAY, 
	// Unneeded states: GL_TEXTURE_2D, GL_TEXTURE_COORD_ARRAY, GL_COLOR_ARRAY	
	glDisable(GL_TEXTURE_2D);
	glDisableClientState(GL_TEXTURE_COORD_ARRAY);
	//glDisableClientState(GL_COLOR_ARRAY);
	
	glColorPointer(4, GL_FLOAT, 0, colors);
	glVertexPointer(2, GL_FLOAT, 0, vertices);	
	glDrawArrays(GL_TRIANGLE_STRIP, 0, (numofpoint+1)*2);
	
	// restore default state
	glEnableClientState(GL_COLOR_ARRAY);
	glEnableClientState(GL_TEXTURE_COORD_ARRAY);
	glEnable(GL_TEXTURE_2D);	
	
	free( vertices );
	free( colors );
	
}

void CirclePlus( CGPoint center,float r1, float r2, CGRect sc1,CGRect ec1 ,CGRect sc2,CGRect ec2, int numofpoint,float rota)
{
	const float coef = (float)M_PI*2/numofpoint;
	
	GLfloat *vertices = calloc( sizeof(GLfloat)*2*(numofpoint+1)*2, 1);
	GLfloat *colors = calloc( sizeof(GLfloat)*4*(numofpoint+1)*2, 1);
	if( ! vertices || ! colors)
		return;
	
	for(NSUInteger i=0;i<(numofpoint+1);i++)
	{
		float rads = i*coef + rota/180*3.1415926;
		GLfloat ix1 = r1 * sinf(rads) + center.x;
		GLfloat iy1 = r1 * cosf(rads) + center.y;
		GLfloat ix2 = r2 * sinf(rads) + center.x;
		GLfloat iy2 = r2 * cosf(rads) + center.y;
		
		vertices[i*4] = ix1 * CC_CONTENT_SCALE_FACTOR();
		vertices[i*4+1] = iy1 * CC_CONTENT_SCALE_FACTOR();
		vertices[i*4+2] = ix2 * CC_CONTENT_SCALE_FACTOR();
		vertices[i*4+3] = iy2 * CC_CONTENT_SCALE_FACTOR();
		
		float trf = sinf((float)i/numofpoint*3.1415926);
		CGRect color1 = CWColorTransform(sc1, ec1, trf);
		CGRect color2 = CWColorTransform(sc2, ec2, trf);
		
		colors[i*8] = color1.origin.x;
		colors[i*8+1] = color1.origin.y;
		colors[i*8+2] = color1.size.width;
		colors[i*8+3] = color1.size.height;
		
		colors[i*8+4] = color2.origin.x;
		colors[i*8+5] = color2.origin.y;
		colors[i*8+6] = color2.size.width;
		colors[i*8+7] = color2.size.height;
	}
	
	// Default GL states: GL_TEXTURE_2D, GL_VERTEX_ARRAY, GL_COLOR_ARRAY, GL_TEXTURE_COORD_ARRAY
	// Needed states: GL_VERTEX_ARRAY, 
	// Unneeded states: GL_TEXTURE_2D, GL_TEXTURE_COORD_ARRAY, GL_COLOR_ARRAY	
	glDisable(GL_TEXTURE_2D);
	glDisableClientState(GL_TEXTURE_COORD_ARRAY);
	//glDisableClientState(GL_COLOR_ARRAY);
	
	glColorPointer(4, GL_FLOAT, 0, colors);
	glVertexPointer(2, GL_FLOAT, 0, vertices);	
	glDrawArrays(GL_TRIANGLE_STRIP, 0, (numofpoint+1)*2);
	
	// restore default state
	glEnableClientState(GL_COLOR_ARRAY);
	glEnableClientState(GL_TEXTURE_COORD_ARRAY);
	glEnable(GL_TEXTURE_2D);	
	
	free( vertices );
	free( colors );
	
}

void advancedCircle( CGPoint center,float r1, float r2, CGRect sc1,CGRect ec1 ,CGRect sc2,CGRect ec2, int numofpoint,float radstart,float radend)
{
	if(r1==r2)return;
	
	float coef = (radend-radstart)/numofpoint;
	float pif = (float)M_PI/180;
	
	GLfloat *vertices = calloc( sizeof(GLfloat)*2*(numofpoint+1)*2, 1);
	GLfloat *colors = calloc( sizeof(GLfloat)*4*(numofpoint+1)*2, 1);
	if( ! vertices || ! colors)
		return;
	
	for(NSUInteger i=0;i<(numofpoint+1);i++)
	{
		float rads = (i*coef + radstart)*pif;
		GLfloat ix1 = r1 * sinf(rads) + center.x;
		GLfloat iy1 = r1 * cosf(rads) + center.y;
		GLfloat ix2 = r2 * sinf(rads) + center.x;
		GLfloat iy2 = r2 * cosf(rads) + center.y;
		
		vertices[i*4] = ix1 * CC_CONTENT_SCALE_FACTOR();
		vertices[i*4+1] = iy1 * CC_CONTENT_SCALE_FACTOR();
		vertices[i*4+2] = ix2 * CC_CONTENT_SCALE_FACTOR();
		vertices[i*4+3] = iy2 * CC_CONTENT_SCALE_FACTOR();
		
		float trf = sinf((float)i/numofpoint*3.1415926);
		CGRect color1 = CWColorTransform(sc1, ec1, trf);
		CGRect color2 = CWColorTransform(sc2, ec2, trf);
		
		colors[i*8] = color1.origin.x;
		colors[i*8+1] = color1.origin.y;
		colors[i*8+2] = color1.size.width;
		colors[i*8+3] = color1.size.height;
		
		colors[i*8+4] = color2.origin.x;
		colors[i*8+5] = color2.origin.y;
		colors[i*8+6] = color2.size.width;
		colors[i*8+7] = color2.size.height;
	}
	
	// Default GL states: GL_TEXTURE_2D, GL_VERTEX_ARRAY, GL_COLOR_ARRAY, GL_TEXTURE_COORD_ARRAY
	// Needed states: GL_VERTEX_ARRAY, 
	// Unneeded states: GL_TEXTURE_2D, GL_TEXTURE_COORD_ARRAY, GL_COLOR_ARRAY	
	glDisable(GL_TEXTURE_2D);
	glDisableClientState(GL_TEXTURE_COORD_ARRAY);
	//glDisableClientState(GL_COLOR_ARRAY);
	
	glColorPointer(4, GL_FLOAT, 0, colors);
	glVertexPointer(2, GL_FLOAT, 0, vertices);	
	glDrawArrays(GL_TRIANGLE_STRIP, 0, (numofpoint+1)*2);
	
	// restore default state
	glEnableClientState(GL_COLOR_ARRAY);
	glEnableClientState(GL_TEXTURE_COORD_ARRAY);
	glEnable(GL_TEXTURE_2D);	
	
	free( vertices );
	free( colors );
	
}

void attackEffectFix(CGPoint center,float r,CGRect thecolor,float rota)
{
	float an = (float)M_PI/3;
	float addition = rota*an/60;
	GLfloat vertices[16];
	GLfloat colors[32];
	
	vertices[0] = center.x;
	vertices[1] = center.y;
	
	colors[0] = thecolor.origin.x;
	colors[1] = thecolor.origin.y;
	colors[2] = thecolor.size.width;
	colors[3] = thecolor.size.height;
	
	for(int i=0;i<7;i++){
		vertices[i*2+2] = r * sinf(an * i + addition);
		vertices[i*2+3] = r * cosf(an * i + addition);
		if(i%2){
			vertices[i*2+2]/=10;
			vertices[i*2+3]/=10;
		}
		vertices[i*2+2]+=center.x;
		vertices[i*2+3]+=center.y;
		colors[i*4+4] = colors[i*4+5] = colors[i*4+6] = colors[i*4+7] = 0;
	}
	
	glDisable(GL_TEXTURE_2D);
	glDisableClientState(GL_TEXTURE_COORD_ARRAY);
	//glDisableClientState(GL_COLOR_ARRAY);
	
	glColorPointer(4, GL_FLOAT, 0, colors);
	glVertexPointer(2, GL_FLOAT, 0, vertices);	
	glDrawArrays(GL_TRIANGLE_FAN, 0, 8);
	
	// restore default state
	glEnableClientState(GL_COLOR_ARRAY);
	glEnableClientState(GL_TEXTURE_COORD_ARRAY);
	glEnable(GL_TEXTURE_2D);	
}

-(void)draw{
	CCNode *par = [self parent];
	float scl = par.scale;
	float aw = 4.0/scl;
	selfDraw(theShape, CGRectMultiple(selfcolor, transparency), BlackWithAlpha(0),aw);
		
	if(soulMove && sd>50){
		float sf = sd/soulSpeed;
		advancedCircle(ccp(0,0),80,90,BlackWithAlpha(0),BlackWithAlpha(0), BlackWithAlpha(0),selfcolor,64, -sf*140, sf*140);
		advancedCircle(ccp(0,0),90,100,BlackWithAlpha(0),selfcolor,BlackWithAlpha(0),BlackWithAlpha(0),64, -sf*140, sf*140);
	}
	
	if(canSee){
		float dx = selfsize*sqrtf(3.0)/2;
		float dy = selfsize/2;
		CGPoint leftpos = ccp(-dx,-dy);
		CGPoint rightpos = ccp(dx,-dy);
		float tran1 = (vd%15)/28.0+0.5;
		float tran2 = abs(vd%15-5)/28.0+0.5;
		CGRect yel1 = CGRectMultiple(YellowWithAlpha(1), tran1);
		CGRect yel2 = CGRectMultiple(YellowWithAlpha(1), tran2);
		attackEffectFix(leftpos, selfsize, yel1, 3);
		attackEffectFix(rightpos, selfsize, yel2, -3);
	}
	
	if(canBeHealed){
		float hf = (float)hd/40*180;
		float sub = self.rotation;
		advancedCircle(ccp(0,0),40*0.8,40,BlackWithAlpha(0),BlackWithAlpha(0),GreenWithAlpha(0),BlackWithAlpha(0), 64,hf-sub,hf+180-sub);
		advancedCircle(ccp(0,0),40,40*1.2,GreenWithAlpha(0),BlackWithAlpha(0),BlackWithAlpha(0),BlackWithAlpha(0), 64,hf-sub,hf-sub+180);
		advancedCircle(ccp(0,0),40*0.8,40,BlackWithAlpha(0),BlackWithAlpha(0),GreenWithAlpha(0),BlackWithAlpha(0), 64,hf-sub+180,hf-sub+360);
		advancedCircle(ccp(0,0),40,40*1.2,GreenWithAlpha(0),BlackWithAlpha(0),BlackWithAlpha(0),BlackWithAlpha(0), 64,hf-sub+180,hf-sub+360);
	}
	
	if(isDrawing){
		float df = (float)dd/60;
		if(dd<=30){
			advancedCircle(ccp(0,0), 60*0.9, 60, BlackWithAlpha(0),BlackWithAlpha(0),PurpleWithAlpha(0),BlackWithAlpha(0), 64, 180-df*360, 180+df*360);
			advancedCircle(ccp(0,0), 60, 60*1.1,PurpleWithAlpha(0),BlackWithAlpha(0), BlackWithAlpha(0),BlackWithAlpha(0), 64, 180-df*360, 180+df*360);
		}
		else {
			advancedCircle(ccp(0,0), 60*0.9, 60, BlackWithAlpha(0),BlackWithAlpha(0),BlackWithAlpha(0),PurpleWithAlpha(0), 64, -360+df*360, 360-df*360);
			advancedCircle(ccp(0,0), 60, 60*1.1,BlackWithAlpha(0),PurpleWithAlpha(0), BlackWithAlpha(0),BlackWithAlpha(0), 64, -360+df*360, 360-df*360);
		}
	}
	
	if(haveShield){
		draw2Circle(ccp(0,0),0,sr, BlueWithAlpha(0), BlackWithAlpha(1), 64);
		draw2Circle(ccp(0,0), sr, sr*1.05, BlackWithAlpha(1), BlackWithAlpha(0), 64);
	}
	
	if(isAttacking){
		if(ad>0){
			attackEffectFix(ccp(0,0),ad/20,CGRectMultiple(RedWithAlpha(1), transparency),0);
			if(ad<attackDistance*2)
			draw2Circle(ccp(0,0), 0, (ad-attackDistance*2)/20, RedWithAlpha(0), BlackWithAlpha(0), 3);
		}
	}
}

-(void)becomeActiveExplore{
	if(self.visible)return;
	self.visible = YES;
	[self schedule:@selector(updateModeExplore) interval:1.0/30];
}

-(void)becomeActiveVS{
	if(self.visible)return;
	self.visible = YES;
	[self schedule:@selector(updateModeVSEnemy) interval:1.0/30];
}

-(void)becomeActiveShow{
	if(self.visible)return;
	self.visible = YES;
	[self schedule:@selector(updateModeShow) interval:1.0/30];	
}

-(void)updateModeShow{
	if(self.visible==NO){
		[self unschedule:@selector(updateModeExplore)];
		[bullets removeAllObjects];
		return;
	}
	transparency+=0.01;
	if(transparency>1)
		transparency=1;
	
	if(canSee){
		if(vd<60)
			vd+=1;
		else 
			vd=1;
	}
	else 
		vd=0;
	
	if(isDrawing){
		if(dd<=60)
			dd+=1;
		else 
			dd = 0;
	}
	else 
		dd = 0;
	
	if(canBeHealed){
		if(hd<40)
			hd+=1;
		else 
			hd=0;
	}
	else {
		hd=0;
	}
	
	if(soulMove){
		if(sd<soulSpeed)
			sd+=((int)soulSpeed/60+1);
	}
	else {
		sd=0;
	}
	
	if(isAttacking){
		if(ad<attackDistance*3)
			ad+=80;
	}
	else {
		ad=0;
	}
	
	if(haveShield){
		if(sr<70)sr+=5;
	}
	else sr=0;
	
}

-(void)updateModeExplore{
	GameView *gview = [GameView sharedGameView];

	if(self.visible==NO){
		[self unschedule:@selector(updateModeExplore)];
		[[AnimationLayer sharedAnimationLayer] addMessage:@"BOOM!" At:self.position For:1 FontSize:40];
		[[AnimationLayer sharedAnimationLayer] showExplosionAt:self.position WithTime:0.5 Color:WhiteWithAlpha(1) WaveSpeed:50];
		[bullets removeAllObjects];
		return;
	}
	transparency+=0.016;
	if(transparency>1)
		transparency=1;
	if(currentEnergy>maxEnergy)currentEnergy=maxEnergy;
	if(currentEnergy<0){
		currentEnergy=0;
		self.visible=NO;
		return;
	}
	
	if(haveShield){
		if(sr<70)sr+=5;
	}
	else sr=0;
	
	if(isAttacking){
		if(ad<attackDistance*3){
			ad+=80;
		}
		if([self isEqual:gview.mc]){
			for(ApostleBasis *e in gview.allEnemies){
				if(e.visible && WhetherBeAttacked(self.position, self.rotation,e.position, ad/20)){
					e.currentEnergy-=e.maxEnergy/120+10;
					[[AnimationLayer sharedAnimationLayer] showExplosionAt:e.position WithTime:0.1 Color:e.selfcolor WaveSpeed:30 Shape:6];
				}
			}
		}
		else {
			ApostleBasis *c = gview.mc;
			if(c.visible && WhetherBeAttacked(self.position, self.rotation,c.position, ad/20)){
				c.currentEnergy-=c.maxEnergy/120+10;
				[[AnimationLayer sharedAnimationLayer] showExplosionAt:c.position WithTime:0.1 Color:c.selfcolor WaveSpeed:30 Shape:6];
			}
		}
	}
	else {
		if(ad>attackDistance*2){
			float pif = (float)M_PI/180;
			float alength = ad/20;
			CGRect randomred = CGRectMake(0.5+CCRANDOM_0_1()/2,0,0, 1);

			for(int ac=0;ac<3;ac++){
				float aangle = ((ac-1)*120+self.rotation)*pif;
				CGPoint afp = ccpAdd(self.position, ccp(alength*sinf(aangle),alength*cosf(aangle)));
				float arota = 60+120*ac+self.rotation;
				[self shoot:randomred From:afp Angle:arota Speed:60 Range:alength*3 Damage:ad/2 Shape:2 Radius:alength/3];
			}
		}
		ad=0;
	}
	if(soulMove){
		if(sd<soulSpeed)
			sd+=((int)soulSpeed/60+1);
	}
	else {
		if(sd>50){
			CGRect rlg = CGRectMake(0, 0.5+CCRANDOM_0_1()/2, 0.5+CCRANDOM_0_1()/2, 1);
			[[AnimationLayer sharedAnimationLayer] showExplosionAt:self.position WithTime:0.2 Color:rlg WaveSpeed:-12 Shape:6];
			float cangle = self.rotation*(float)M_PI/180;
			CGPoint addi = ccp(sd*sinf(cangle),sd*cosf(cangle));
			self.position = ccpAdd(self.position, addi);
			self.rotation = self.rotation+180;
			[[AnimationLayer sharedAnimationLayer] showExplosionAt:self.position WithTime:0.2 Color:rlg WaveSpeed:12 Shape:6];	
			
			[self shoot:rlg From:self.position Angle:self.rotation Speed:60 Range:attackDistance Damage:attackDistance Shape:2 Radius:selfsize*0.8];
			
			if(AIType==0){
				CGRect bound = CGRectMake(0, 0, gview.mapSize.width, gview.mapSize.height);
				if(CGRectContainsPoint(bound, self.position)){
					gview.centerPosition = self.position;
					[gview setCameraCenterAt:self.position];
				}
			}
		}
		sd = 0;
	}
	
	if(isDrawing){
		if(dd<=60){
			dd+=1;
			int lasernumber = dd-30;
			if(lasernumber<=(int)drawSpeed && lasernumber>0){
				float ang = (self.rotation+30*(CCRANDOM_0_1()-0.5))*(float)M_PI/180;
				CGPoint firepos = ccpAdd(self.position, ccp(60*sinf(ang),60*cosf(ang)));
				CGRect ranpur = CGRectMake(CCRANDOM_0_1()*0.8+0.2,0, CCRANDOM_0_1()*0.8+0.2, CCRANDOM_0_1());
				float laserdamage = attackDistance/lasernumber;
				if(laserdamage<attackDistance/6)
					laserdamage = attackDistance/6;
				[self shoot:ranpur From:firepos Angle:self.rotation Speed:60 Range:attackDistance Damage:laserdamage Shape:1 Radius:selfsize];
			}
		}
		else dd=0;
	}
	else {
		dd=0;
	}
	
	if(canBeHealed){
		if(hd<40){
			hd+=1;
		}
		else {
			currentEnergy+=maxEnergy*healDistance/100;
			if(currentEnergy>maxEnergy)
				currentEnergy=maxEnergy;
			hd=0;
		}
	}
	else {
		hd=0;
	}
	if(canSee){
		if(vd<60)
			vd+=1;
		else 
			vd=1;

		if(vd%15==0){
			float a1 = (self.rotation+240)*(float)M_PI/180;
			float dx1 = self.selfsize*sinf(a1);
			float dy1 = self.selfsize*cosf(a1);
			CGPoint left = ccpAdd(self.position, ccp(dx1,dy1));
			CGRect randomyellow = CGRectMake(CCRANDOM_0_1()*0.8+0.2,CCRANDOM_0_1()*0.8+0.2,0,CCRANDOM_0_1());
			[self shoot:randomyellow From:left Angle:self.rotation+6*CCRANDOM_0_1() Speed:40 Range:attackDistance Damage:attackDistance/3 Shape:2 Radius:selfsize/2];
		}
		if(vd%15==5){
			float a2 = (self.rotation+120)*(float)M_PI/180;
			float dx2 = self.selfsize*sinf(a2);
			float dy2 = self.selfsize*cosf(a2);
			CGPoint right = ccpAdd(self.position, ccp(dx2,dy2));
			CGRect randomyellow = CGRectMake(CCRANDOM_0_1()*0.8+0.2,CCRANDOM_0_1()*0.8+0.2,0,CCRANDOM_0_1());							
			[self shoot:randomyellow From:right Angle:self.rotation-6*CCRANDOM_0_1() Speed:40 Range:attackDistance Damage:attackDistance/3 Shape:2 Radius:selfsize/2];
		}
	}
	
	else {
		vd=0;
	}
	NSMutableArray *allbullets = [NSMutableArray arrayWithArray:bullets];
	int bcounter=0;
	
	for(NSMutableDictionary *abullet in allbullets){
		BOOL whetherDelete = NO;
		CGPoint sp = [[abullet objectForKey:kBStart] CGPointValue];
		CGPoint cp = [[abullet objectForKey:kBPosition] CGPointValue];
		ApostleBasis *target = [abullet objectForKey:kBTarget];

		int type = [[abullet objectForKey:kBShape] intValue];
		float ra = [[abullet objectForKey:kBRange] floatValue];
		float r = [[abullet objectForKey:kBRadius] floatValue];
		
		if(ccpDistance(sp, cp)>ra){
			whetherDelete = YES;
		}
		if(target && target.visible==NO){
			whetherDelete = YES;
		}
		CGRect bcolor;
		int bulletdamage;
		if(![self isEqual:gview.mc]){
			ApostleBasis *c = [GameView sharedGameView].mc;
			CGPoint cpos = c.position;
			if(c.visible && ccpDistance(cp, cpos)<(r+c.selfsize)/2){
				bcolor = [[abullet objectForKey:kBColor] CGRectValue];
				bulletdamage = [[abullet objectForKey:kBDamage] intValue];
				
				if(type>=3){
					whetherDelete = YES;
					[[AnimationLayer sharedAnimationLayer] showExplosionAt:cp WithTime:0.4 Color:bcolor WaveSpeed:35];
				}else {
					[[AnimationLayer sharedAnimationLayer] showExplosionAt:cp WithTime:0.1 Color:bcolor WaveSpeed:30 Shape:6];
					[[AnimationLayer sharedAnimationLayer] showExplosionAt:cp WithTime:0.1 Color:bcolor WaveSpeed:15 Shape:6];
				}
				if(c.haveShield){
					c.currentEnergy-=bulletdamage/10;
					whetherDelete = YES;
				}
				else c.currentEnergy-=bulletdamage;
				if(c.canBeHealed){
					int addamage = c.maxEnergy/20+bulletdamage;
					c.currentEnergy-=addamage;
				}
			}
		}
		else {
			for(ApostleBasis *e in [GameView sharedGameView].allEnemies){
				CGPoint epos = e.position;
				if(e.visible && ccpDistance(cp, epos)<(r+e.selfsize)/2){
					bcolor = [[abullet objectForKey:kBColor] CGRectValue];
					bulletdamage = [[abullet objectForKey:kBDamage] intValue];
					if(type>=3){
						whetherDelete = YES;
						[[AnimationLayer sharedAnimationLayer] showExplosionAt:cp WithTime:0.4 Color:bcolor WaveSpeed:35];
					}else {
						[[AnimationLayer sharedAnimationLayer] showExplosionAt:cp WithTime:0.1 Color:bcolor WaveSpeed:30 Shape:6];
					}
					if(e.haveShield){
						e.currentEnergy-=bulletdamage/10;
						whetherDelete = YES;
					}
					else e.currentEnergy-=bulletdamage;
					if(e.canBeHealed)
						e.currentEnergy-=bulletdamage;
				}
			}
		}
		if(whetherDelete)
			[bullets removeObjectAtIndex:bcounter];
		else {
			float bulletspeed = [[abullet objectForKey:kBSpeed] floatValue];
			float bulletrotation = [[abullet objectForKey:kBRotation] floatValue];
			if(target){
				float ta =  AngleOfTwoPoints(cp, target.position);
				bulletrotation = nextAngle(bulletrotation, ta, 30);
			}
				
			float dx = bulletspeed * sinf(bulletrotation * (float)M_PI/180);
			float dy = bulletspeed * cosf(bulletrotation * (float)M_PI/180);
			CGPoint newpos = ccpAdd(cp, ccp(dx,dy));
			NSMutableDictionary *anewbullet = [NSMutableDictionary dictionaryWithDictionary:abullet];
			[anewbullet setObject:[NSValue valueWithCGPoint:newpos] forKey:kBPosition];
			[anewbullet setObject:[NSNumber numberWithFloat:bulletrotation] forKey:kBRotation];
			[bullets replaceObjectAtIndex:bcounter withObject:anewbullet];
			bcounter++;
		}
	}
}

-(void)updateModeVSEnemy{
	GameView *gview = [GameView sharedGameView];
	transparency+=0.016;
	if(transparency>1)
		transparency=1;
	if(currentEnergy>maxEnergy)currentEnergy=maxEnergy;
	
	if(currentEnergy<0 && self.visible == YES){
		self.visible = NO;
		[[AnimationLayer sharedAnimationLayer] addMessage:@"BOOM!" At:self.position For:1 FontSize:40];
		[[AnimationLayer sharedAnimationLayer] showExplosionAt:self.position WithTime:0.5 Color:WhiteWithAlpha(1) WaveSpeed:50];
		[bullets removeAllObjects];
		return;		
	}
	
	if(currentEnergy>1)
		self.visible = YES;
	
	if(isAttacking){		
		ApostleBasis *c = gview.mc;
		if(c.visible && WhetherBeAttacked(self.position, self.rotation,c.position, ad/20)){
			c.currentEnergy-=c.maxEnergy/120+10;
			[[AnimationLayer sharedAnimationLayer] showExplosionAt:c.position WithTime:0.1 Color:c.selfcolor WaveSpeed:30 Shape:6];
		}
		
	}
	else {
		if(ad>attackDistance*2){
			float pif = (float)M_PI/180;
			float alength = ad/20;
			CGRect randomred = CGRectMake(0.5+CCRANDOM_0_1()/2,0,0, 1);
			
			for(int ac=0;ac<3;ac++){
				float aangle = ((ac-1)*120+self.rotation)*pif;
				CGPoint afp = ccpAdd(self.position, ccp(alength*sinf(aangle),alength*cosf(aangle)));
				float arota = 60+120*ac+self.rotation;
				[self shoot:randomred From:afp Angle:arota Speed:60 Range:alength*3 Damage:ad/4 Shape:2 Radius:alength/3];
			}
		}
		ad=0;
	}
	if(soulMove){
	}
	else {
		if(sd>50){
			CGRect rlg = CGRectMake(0, 0.5+CCRANDOM_0_1()/2, 0.5+CCRANDOM_0_1()/2, 1);
			[[AnimationLayer sharedAnimationLayer] showExplosionAt:self.position WithTime:0.2 Color:rlg WaveSpeed:-12 Shape:6];
			float cangle = self.rotation*(float)M_PI/180;
			CGPoint addi = ccp(sd*sinf(cangle),sd*cosf(cangle));
			self.position = ccpAdd(self.position, addi);
			//self.rotation = self.rotation+180;
			[[AnimationLayer sharedAnimationLayer] showExplosionAt:self.position WithTime:0.2 Color:rlg WaveSpeed:12 Shape:6];	
			
			[self shoot:rlg From:self.position Angle:self.rotation Speed:60 Range:attackDistance Damage:attackDistance Shape:2 Radius:selfsize*0.8];
		}
		sd = 0;
	}
	
	if(isDrawing){
		if(dd<=60){
			dd+=1;
			int lasernumber = dd-30;
			if(lasernumber<=(int)drawSpeed && lasernumber>0){
				float ang = (self.rotation+30*(CCRANDOM_0_1()-0.5))*(float)M_PI/180;
				CGPoint firepos = ccpAdd(self.position, ccp(60*sinf(ang),60*cosf(ang)));
				CGRect ranpur = CGRectMake(CCRANDOM_0_1()*0.8+0.2,0, CCRANDOM_0_1()*0.8+0.2, CCRANDOM_0_1());
				float laserdamage = attackDistance/lasernumber;
				if(laserdamage<attackDistance/8)
					laserdamage = attackDistance/8;
				[self shoot:ranpur From:firepos Angle:self.rotation Speed:60 Range:attackDistance Damage:laserdamage Shape:1 Radius:selfsize];
			}
		}
		else dd=0;
	}
	else {
		dd=0;
	}
	
	if(canSee){
		
		if(vd%15==0){
			float a1 = (self.rotation+240)*(float)M_PI/180;
			float dx1 = self.selfsize*sinf(a1);
			float dy1 = self.selfsize*cosf(a1);
			CGPoint left = ccpAdd(self.position, ccp(dx1,dy1));
			CGRect randomyellow = CGRectMake(CCRANDOM_0_1()*0.8+0.2,CCRANDOM_0_1()*0.8+0.2,0,CCRANDOM_0_1());
			[self shoot:randomyellow From:left Angle:self.rotation+6*CCRANDOM_0_1() Speed:40 Range:attackDistance Damage:attackDistance/3 Shape:2 Radius:selfsize/2];
		}
		if(vd%15==5){
			float a2 = (self.rotation+120)*(float)M_PI/180;
			float dx2 = self.selfsize*sinf(a2);
			float dy2 = self.selfsize*cosf(a2);
			CGPoint right = ccpAdd(self.position, ccp(dx2,dy2));
			CGRect randomyellow = CGRectMake(CCRANDOM_0_1()*0.8+0.2,CCRANDOM_0_1()*0.8+0.2,0,CCRANDOM_0_1());							
			[self shoot:randomyellow From:right Angle:self.rotation-6*CCRANDOM_0_1() Speed:40 Range:attackDistance Damage:attackDistance/3 Shape:2 Radius:selfsize/2];
		}
	}
	
	else {
		vd=0;
	}
	NSMutableArray *allbullets = [NSMutableArray arrayWithArray:bullets];
	int bcounter=0;
	
	for(NSMutableDictionary *abullet in allbullets){
		BOOL whetherDelete = NO;
		CGPoint sp = [[abullet objectForKey:kBStart] CGPointValue];
		CGPoint cp = [[abullet objectForKey:kBPosition] CGPointValue];
		ApostleBasis *target = [abullet objectForKey:kBTarget];
		
		int type = [[abullet objectForKey:kBShape] intValue];
		float ra = [[abullet objectForKey:kBRange] floatValue];
		float r = [[abullet objectForKey:kBRadius] floatValue];
		
		if(ccpDistance(sp, cp)>ra){
			whetherDelete = YES;
		}
		if(target && target.visible==NO){
			whetherDelete = YES;
		}
		CGRect bcolor;
		int bulletdamage;
		
		ApostleBasis *c = [GameView sharedGameView].mc;
		CGPoint cpos = c.position;
		if(c.visible && ccpDistance(cp, cpos)<(r+c.selfsize)/2){
			bcolor = [[abullet objectForKey:kBColor] CGRectValue];
			bulletdamage = [[abullet objectForKey:kBDamage] intValue];
			
			if(type>=3){
				whetherDelete = YES;
				[[AnimationLayer sharedAnimationLayer] showExplosionAt:cp WithTime:0.4 Color:bcolor WaveSpeed:35];
			}else {
				[[AnimationLayer sharedAnimationLayer] showExplosionAt:cp WithTime:0.1 Color:bcolor WaveSpeed:30 Shape:6];
				[[AnimationLayer sharedAnimationLayer] showExplosionAt:cp WithTime:0.1 Color:bcolor WaveSpeed:15 Shape:6];
			}
			if(c.haveShield){
				c.currentEnergy-=bulletdamage/10;
				whetherDelete = YES;
			}
			else c.currentEnergy-=bulletdamage;
			if(c.canBeHealed){
				int addamage = c.maxEnergy/20+bulletdamage;
				c.currentEnergy-=addamage;
			}
		}
		
		if(whetherDelete)
			[bullets removeObjectAtIndex:bcounter];
		else {
			float bulletspeed = [[abullet objectForKey:kBSpeed] floatValue];
			float bulletrotation = [[abullet objectForKey:kBRotation] floatValue];
			if(target){
				float ta =  AngleOfTwoPoints(cp, target.position);
				bulletrotation = nextAngle(bulletrotation, ta, 30);
			}
			
			float dx = bulletspeed * sinf(bulletrotation * (float)M_PI/180);
			float dy = bulletspeed * cosf(bulletrotation * (float)M_PI/180);
			CGPoint newpos = ccpAdd(cp, ccp(dx,dy));
			NSMutableDictionary *anewbullet = [NSMutableDictionary dictionaryWithDictionary:abullet];
			[anewbullet setObject:[NSValue valueWithCGPoint:newpos] forKey:kBPosition];
			[anewbullet setObject:[NSNumber numberWithFloat:bulletrotation] forKey:kBRotation];
			[bullets replaceObjectAtIndex:bcounter withObject:anewbullet];
			bcounter++;
		}
	}
	
}

-(void)AIturnto:(float)angle moveAtSpeed:(float)speed{
	[self turnto:angle atSpeed:4+CCRANDOM_0_1()];
	float xmove,ymove;
	xmove = speed*sin(angle/360*2*3.1415926);
	ymove = speed*cos(angle/360*2*3.1415926);
	self.position = ccpAdd(self.position, ccp(xmove,ymove));
}

-(void)doAIActionTo:(ApostleBasis *)target AtSpeed:(float)s{
	if(target.visible==NO || transparency<0.95){
		currentEnergy = maxEnergy;
		return;
	}
	
	float ang = AngleOfTwoPoints(self.position, target.position);
	float distance = ccpDistance(self.position, target.position);
	float sdis = ccpDistance(startPosition, target.position);
	
	if(s<=10 && sdis>target.attackDistance*1.2 && distance>attackDistance){
		self.position = startPosition;
		return;
	}

	switch (self.AIType) {
		case 1:
			canSee = YES;
			if(sd>=soulSpeed && (distance<=sd/2 || distance>=sd+80))
				soulMove = NO;
			else 
				soulMove = YES;			
			if(distance>=sd*2)
				[self AIturnto:ang moveAtSpeed:s];
			else 
				self.rotation = ang;
			break;
		case 2:
			isDrawing = YES;
			if(sd>=soulSpeed && (distance<=sd/2 || distance>=sd+80))
				soulMove = NO;
			else 
				soulMove = YES;
			
			if(distance>sd*2)
				[self AIturnto:ang moveAtSpeed:s];
			else 
				self.rotation = ang;
			break;
		case 3:
			isAttacking = YES;
			
			if(sd>=soulSpeed)
				soulMove = NO;
			else 
				soulMove = YES;
			
			[self AIturnto:ang moveAtSpeed:s];
			if(distance<=5 && ad>=attackDistance*3)
				isAttacking = NO;
			break;
		case 4:
			canSee = YES;
			
			if(distance>target.visualDistance*0.6)
				[self AIturnto:ang moveAtSpeed:s];
			else 
				self.rotation = ang;
			
			if(sd>=soulSpeed){
				float pf = (float)M_PI/180;
				float an = target.rotation+180;
				float r = 10;
				self.position = ccpAdd(target.position, ccp(r*sinf(an*pf),r*cosf(an*pf)));
				self.rotation = an;
				soulMove = NO;
			}
			else 
				soulMove = YES;
			break;
		case 5:
			isDrawing = YES;
			
			if(distance>target.visualDistance*0.6)
				[self AIturnto:ang moveAtSpeed:s];
			else 
				self.rotation = ang;
			
			if(sd>=soulSpeed && dd>30){
				float pf = (float)M_PI/180;
				float an = target.rotation+180;
				float r = 10;
				self.position = ccpAdd(target.position, ccp(r*sinf(an*pf),r*cosf(an*pf)));
				self.rotation = an;
				soulMove = NO;
			}
			else 
				soulMove = YES;
			
			break;
		case 6:
			canSee = YES;
			isDrawing = YES;
			
			if(distance>target.visualDistance*0.8){
				[self AIturnto:ang moveAtSpeed:s];
			}
			else {
				self.rotation = ang;	
			}
			
			if(sd>=soulSpeed && (distance<=sd/2 || distance>=sd+80))
				soulMove = NO;
			else 
				soulMove = YES;
			
			if(distance>attackDistance*1.2){
				float pf = (float)M_PI/180;
				float an = target.rotation+180;
				float r = target.visualDistance;
				self.position = ccpAdd(target.position, ccp(r*sinf(an*pf),r*cosf(an*pf)));
				self.rotation = an+180;				
			}
			
			break;
		default:
			break;
	}
	
}

@end
