//
//  RecordInfo.m
//  ColorsWar
//
/*
 * HAZ™ Dev Group: http://imhaz.com
 *
 * Copyright (c) 2007-2011 HAZ™ Inc.
 *
 * Written by Hercy Chang 2011-12-08
 *
 */

#import "RecordInfo.h"
#import "DataOfTheAncients.h"

@implementation RecordInfo
-(void)dealloc{
	[super dealloc];
	totalTime = nil;
	totalDrawn = nil;
	bestTime = nil;
	totalKills = nil;
	totalDeathes = nil;
}

-(id)init{
	if((self=[super init])){
		CGSize screenSize = [[CCDirector sharedDirector] winSize];
		
		totalTime = [CCLabelTTF labelWithString:@"" fontName:@"Verdana" fontSize:screenSize.height/18];
		totalDrawn = [CCLabelTTF labelWithString:@"" fontName:@"Verdana" fontSize:screenSize.height/18];
		bestTime = [CCLabelTTF labelWithString:@"" fontName:@"Verdana" fontSize:screenSize.height/18];
		totalKills = [CCLabelTTF labelWithString:@"" fontName:@"Verdana" fontSize:screenSize.height/18];
		totalDeathes = [CCLabelTTF labelWithString:@"" fontName:@"Verdana" fontSize:screenSize.height/18];
		
		float delta = screenSize.height/8;
		totalTime.position = ccp(0,0);
		totalDrawn.position = ccp(0,-delta);
		bestTime.position = ccp(0,-delta*2);
		totalKills.position = ccp(0,delta*2);
		totalDeathes.position = ccp(0,delta);
		
		[self addChild:totalTime];
		[self addChild:totalDrawn];
		[self addChild:bestTime];
		[self addChild:totalKills];
		[self addChild:totalDeathes];
	}
	return self;
}

-(void)showRecordInfo{
	DataOfTheAncients *dota = [DataOfTheAncients sharedDOTA];
	int tdrawn = [dota.drawnPoints count]*6;
	int ttime = [[dota.thebase objectForKey:kTTime] intValue];
	int btime = [[dota.thebase objectForKey:kBTime] intValue];
	int tkills = [[dota.thebase objectForKey:kTKills] intValue];
	int tdeathes = [[dota.thebase objectForKey:kTDeathes] intValue];
	
	if(tdrawn!=0){
		[totalTime setString:[NSString stringWithFormat:@"In the Awake mode You've awaken"]];
		if(ttime%60>=10)
			[totalDrawn setString:[NSString stringWithFormat:@"%d stars in %d:%d ",tdrawn,ttime/60,ttime%60]];
		else 
			[totalDrawn setString:[NSString stringWithFormat:@"%d stars in %d:0%d ",tdrawn,ttime/60,ttime%60]];

		if(btime>0 && btime%60>=10)
			[bestTime setString:[NSString stringWithFormat:@"The quickest one is %d:%d",btime/60,btime%60]];		
		else 
			[bestTime setString:[NSString stringWithFormat:@"The quickest one is %d:0%d",btime/60,btime%60]];		
	}
	else {
		[totalTime setString:[NSString stringWithFormat:@""]];
		[totalDrawn setString:[NSString stringWithFormat:@"You awake nothing"]];
		[bestTime setString:[NSString stringWithFormat:@""]];		
		
	}
	if(tkills==0 && tdeathes==0){
		[totalKills setString:[NSString stringWithFormat:@"You did nothing in the Survival mode"]];
		[totalDeathes setString:[NSString stringWithFormat:@" "]];
	}
	else {
		[totalKills setString:[NSString stringWithFormat:@"In the Survival mode "]];
		[totalDeathes setString:[NSString stringWithFormat:@"You killed %d enemies and died %d times",tkills,tdeathes]];
	}
}

@end
