/*
 * HAZ™ Dev Group: http://imhaz.com
 *
 * Copyright (c) 2007-2011 HAZ™ Inc.
 *
 *
 */

#import <Foundation/Foundation.h>
#import "CCProgressTimer.h"
#import "CCActionInterval.h"

/**
 Progress to percentage
@since v0.99.1
*/
@interface CCProgressTo : CCActionInterval <NSCopying>
{
	float to_;
	float from_;
}
/** Creates and initializes with a duration and a percent */
+(id) actionWithDuration:(ccTime)duration percent:(float)percent;
/** Initializes with a duration and a percent */
-(id) initWithDuration:(ccTime)duration percent:(float)percent;
@end

/**
 Progress from a percentage to another percentage
 @since v0.99.1
 */
@interface CCProgressFromTo : CCActionInterval <NSCopying>
{
	float to_;
	float from_;
}
/** Creates and initializes the action with a duration, a "from" percentage and a "to" percentage */
+(id) actionWithDuration:(ccTime)duration from:(float)fromPercentage to:(float) toPercentage;
/** Initializes the action with a duration, a "from" percentage and a "to" percentage */
-(id) initWithDuration:(ccTime)duration from:(float)fromPercentage to:(float) toPercentage;
@end
