/*
 * HAZ™ Dev Group: http://imhaz.com
 *
 * Copyright (c) 2007-2011 HAZ™ Inc.
 *
 *
 */

#import "CCActionTween.h"


@implementation CCActionTween

+ (id)actionWithDuration:(ccTime)aDuration key:(NSString *)aKey from:(float)aFrom to:(float)aTo {

	return [[[[self class] alloc] initWithDuration:aDuration key:aKey from:aFrom to:aTo] autorelease];
}

- (id)initWithDuration:(ccTime)aDuration key:(NSString *)key from:(float)from to:(float)to {
    
	if ((self = [super initWithDuration:aDuration])) {
    
		key_	= [key copy];
		to_		= to;
		from_	= from;

	}
    
	return self;
}

- (void) dealloc
{
	[key_ release];
	[super dealloc];
}

- (void)startWithTarget:aTarget
{
	[super startWithTarget:aTarget];
	delta_ = to_ - from_;
}

- (void) update:(ccTime) dt
{    
	[target_ setValue:[NSNumber numberWithFloat:to_  - delta_ * (1 - dt)] forKey:key_];
}

- (CCActionInterval *) reverse
{
	return [[self class] actionWithDuration:duration_ key:key_ from:to_ to:from_];
}


@end
